<?php
/* Autor...:  */
/* Esquema.: SEG_Menu.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Metodos de acceso a los campos de la tabla SEG_Menu */
abstract class BaseSEG_MenuBN
{
    /* Campos de la tabla */
    private $s_IdMenu;    // IdMenu: ( no definido )
    private $s_IdTareaHijo;    // IdTareaHijo: ( no definido )
    private $s_Secuencia;    // Secuencia: ( no definido )
    private $s_BotonTexto;    // BotonTexto: ( no definido )
    private $i_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdMenu */
    public function setIdMenu( $s_IdMenu )
    {
        $this->s_IdMenu = $s_IdMenu;
    }

    /* Obtiene el valor del campo IdMenu */
    public function getIdMenu()
    {
        return $this->s_IdMenu;
    }

    /* Establece el valor del campo IdTareaHijo */
    public function setIdTareaHijo( $s_IdTareaHijo )
    {
        $this->s_IdTareaHijo = $s_IdTareaHijo;
    }

    /* Obtiene el valor del campo IdTareaHijo */
    public function getIdTareaHijo()
    {
        return $this->s_IdTareaHijo;
    }

    /* Establece el valor del campo Secuencia */
    public function setSecuencia( $s_Secuencia )
    {
        $this->s_Secuencia = $s_Secuencia;
    }

    /* Obtiene el valor del campo Secuencia */
    public function getSecuencia()
    {
        return $this->s_Secuencia;
    }

    /* Establece el valor del campo BotonTexto */
    public function setBotonTexto( $s_BotonTexto )
    {
        $this->s_BotonTexto = $s_BotonTexto;
    }

    /* Obtiene el valor del campo BotonTexto */
    public function getBotonTexto()
    {
        return $this->s_BotonTexto;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $i_Estado )
    {
        $this->i_Estado = $i_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->i_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdMenu' => $this->getIdMenu(),
            'IdTareaHijo' => $this->getIdTareaHijo(),
            'Secuencia' => $this->getSecuencia(),
            'BotonTexto' => $this->getBotonTexto(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SEG_MenuBN desde un RecordSet */
    public static function retrieveByRs( $o_SEG_MenuRs )
    {
        $o_SEG_MenuBN = new SEG_MenuBN();
        $o_SEG_MenuBN->setIdMenu( $o_SEG_MenuRs[ "IdMenu" ] );
        $o_SEG_MenuBN->setIdTareaHijo( $o_SEG_MenuRs[ "IdTareaHijo" ] );
        $o_SEG_MenuBN->setSecuencia( $o_SEG_MenuRs[ "Secuencia" ] );
        $o_SEG_MenuBN->setBotonTexto( $o_SEG_MenuRs[ "BotonTexto" ] );
        $o_SEG_MenuBN->setEstado( ( integer ) $o_SEG_MenuRs[ "Estado" ] );
        $o_SEG_MenuBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SEG_MenuRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_MenuBN->setUsuarioCreacion( $o_SEG_MenuRs[ "UsuarioCreacion" ] );
        $o_SEG_MenuBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SEG_MenuRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_MenuBN->setUsuarioModificacion( $o_SEG_MenuRs[ "UsuarioModificacion" ] );
        return $o_SEG_MenuBN;
    }
}
?>